import pickle

# načtení získaného slovníku trojic
# ~ je to binární soubor => nedochází k žádné interpretaci pomocí kódování
with open('informace.pickle', mode='br') as soubor:
    hustoty = pickle.load(soubor)

# zjištění nejdelšího názvu země
nejdelší_název = max({len(stát) for stát in hustoty})
# výpis
for pořadí, (země, informace) in enumerate(
    # přes co cyklím
    sorted(
        # co řadíme (jsou to dvojce!)
        hustoty.items(),
        # podle čeho řadíme (hustota z druhého prvku dvojice)
        key=lambda info: info[-1][-1],
        # výsledek vypíšeme v opačném pořadí
        reverse=True
    ),
    # od jakého čísla enumerate() začíná počítat
    start=1
):
    # rozbalení údajů o zemi do samostatných proměnných
    plocha, obyvatel, hustota = informace
    # výpis údajů o zemích
    # ~ jako bych napsal {země:<44}
    print(f'{pořadí:>3} {země:<{nejdelší_název}} --> {obyvatel} obyvatel na {plocha} km^2 => hustota {hustota:.0f}')
